<?php

require_once("Router/Router.php");
require_once("Router/Response.php");
require_once("Router/Route.php");
require_once("BancaDati/BancaDati.php");
require_once("User.php");

use Router\Response;
use Router\Router;
use Router\Route;
use BancaDati\BancaDati;

$app = new Router("/DirektiveDesDons");
$db = new BancaDati();

$app->use("/", function (array &$req, Response $res) {
    if(isset($_COOKIE["TOKEN"])){
        $user = new User();
        if($user->loginWithToken($_COOKIE["TOKEN"])){
            $req["user"] = $user;
        }
    }
});

$app->get("/", function (array $req, Response $res) use ($db) {
    $res->send("Hello World");
    //var_dump($req["user"]);
});

/*
 * User
 */

$app->get("/user", function (array $req, Response $res) {
    if(isset($req["user"])){
        $res->json(["id" => $req["user"]->id, "username" => $req["user"]->username, "email" => $req["user"]->email]);
    }else {
        $res->json(["status" => 403, "message" => "You are not logged in. Goto '/login' to login"]);
    }
});
$app->get("/user/:id", function (array $req, Response $res) use ($db) {
    $db->select("utente", ["username" => $req["id"]]);
    $res->send("user " . $req["params"]["id"]);
});
$app->post("/signup", function (array $req, Response $res) use ($db) {
    $newUsername = $req["body"]["username"];
    $newPassword = $req["body"]["password"];
    $newEmail = $req["body"]["email"];
    $db->insert("utente", ["email" => "$newEmail", "parolaDordine" => "$newPassword", "nomeUtente" => "$newUsername"]);

    $res->send("Account Created", 201);
});

$app->post("/login", function( array $req, Response $res) use ($db) {
    $username = $req["body"]["username"];
    $password = $req["body"]["password"];

    $user = new User();
    $usertoken = $user->loginWithUsername($username, $password);

    if($usertoken){
        setcookie("TOKEN", $usertoken, time()+3600); // 1h
        $res->send("Login successful" . "token: " . $usertoken, 200);
    }else{
        $res->send("Login failed", 403);
    }
});

/*
 * Ingredients
 */
$app->route("/ingredient")
    ->get(function (array $req, Response $res) use ($db) {
        $res->json(["status" => 200, "data" => $db->select("ingredienti")]);
    })
    ->post(function (array $req, Response $res) use ($db) {
        $name = $req["body"]["name"];
        $calories = $req["body"]["calories"];
        $quantity = $req["body"]["quantity"];
        $unit = $req["body"]["unit"];
        $price = $req["body"]["price"];

        $unitInTable = $db->select("folla", ["unita" => $unit]);
        if(count($unitInTable) > 1){
            $res->json(["status" => "400", "message" => "Unit: " . $unit . " does not exist. Please create unit first" ]);
            return;
        }
        $unitId = $unitInTable[0]["id"];

        $id = $db->insert("ingredienti", ["cognome" => "$name", "calorie" => "$calories", "quantita" => "$quantity", "follaID" => $unitId, "prezzo" => "$price"]);
        if(!$id){
            $res->json(["status" => 400,
                "message" => "Something went wrong when creating the Ingredient"], 500);
            return;
        }

        $res->json(["status" => "200",
            "message" => "New ingredient has been listed",
            "ingredient" => $db->select("ingredienti", ["id" => $id])]);
    });
$app->get("/ingredient/:id", function (array $req, Response $res) use ($db) {
    $id = $req["params"]["id"];
    $ingredient = $db->select("ingredienti", ["id" => $id])[0];
    $res->json(["status" => 200, "data" => $ingredient]);
});


$app->start();